package java.sql;

public interface Connection {
   int TRANSACTION_NONE = 0;
   int TRANSACTION_READ_UNCOMMITTED = 1;
   int TRANSACTION_READ_COMMITTED = 2;
   int TRANSACTION_REPEATABLE_READ = 4;
   int TRANSACTION_SERIALIZABLE = 8;

   Statement createStatement() throws SQLException;

   PreparedStatement prepareStatement(String var1) throws SQLException;

   CallableStatement prepareCall(String var1) throws SQLException;

   String nativeSQL(String var1) throws SQLException;

   void setAutoCommit(boolean var1) throws SQLException;

   boolean getAutoCommit() throws SQLException;

   void commit() throws SQLException;

   void rollback() throws SQLException;

   void close() throws SQLException;

   boolean isClosed() throws SQLException;

   DatabaseMetaData getMetaData() throws SQLException;

   void setReadOnly(boolean var1) throws SQLException;

   boolean isReadOnly() throws SQLException;

   void setCatalog(String var1) throws SQLException;

   String getCatalog() throws SQLException;

   void setTransactionIsolation(int var1) throws SQLException;

   int getTransactionIsolation() throws SQLException;

   SQLWarning getWarnings() throws SQLException;

   void clearWarnings() throws SQLException;
}
