package java.sql;

import java.io.InputStream;
import java.math.BigDecimal;

public interface PreparedStatement extends Statement {
   ResultSet executeQuery() throws SQLException;

   int executeUpdate() throws SQLException;

   void setNull(int var1, int var2) throws SQLException;

   void setBoolean(int var1, boolean var2) throws SQLException;

   void setByte(int var1, byte var2) throws SQLException;

   void setShort(int var1, short var2) throws SQLException;

   void setInt(int var1, int var2) throws SQLException;

   void setLong(int var1, long var2) throws SQLException;

   void setFloat(int var1, float var2) throws SQLException;

   void setDouble(int var1, double var2) throws SQLException;

   void setBigDecimal(int var1, BigDecimal var2) throws SQLException;

   void setString(int var1, String var2) throws SQLException;

   void setBytes(int var1, byte[] var2) throws SQLException;

   void setDate(int var1, Date var2) throws SQLException;

   void setTime(int var1, Time var2) throws SQLException;

   void setTimestamp(int var1, Timestamp var2) throws SQLException;

   void setAsciiStream(int var1, InputStream var2, int var3) throws SQLException;

   void setUnicodeStream(int var1, InputStream var2, int var3) throws SQLException;

   void setBinaryStream(int var1, InputStream var2, int var3) throws SQLException;

   void clearParameters() throws SQLException;

   void setObject(int var1, Object var2, int var3, int var4) throws SQLException;

   void setObject(int var1, Object var2, int var3) throws SQLException;

   void setObject(int var1, Object var2) throws SQLException;

   boolean execute() throws SQLException;
}
