package java.sql;

import java.io.InputStream;
import java.math.BigDecimal;

public interface ResultSet {
   boolean next() throws SQLException;

   void close() throws SQLException;

   boolean wasNull() throws SQLException;

   String getString(int var1) throws SQLException;

   boolean getBoolean(int var1) throws SQLException;

   byte getByte(int var1) throws SQLException;

   short getShort(int var1) throws SQLException;

   int getInt(int var1) throws SQLException;

   long getLong(int var1) throws SQLException;

   float getFloat(int var1) throws SQLException;

   double getDouble(int var1) throws SQLException;

   BigDecimal getBigDecimal(int var1, int var2) throws SQLException;

   byte[] getBytes(int var1) throws SQLException;

   Date getDate(int var1) throws SQLException;

   Time getTime(int var1) throws SQLException;

   Timestamp getTimestamp(int var1) throws SQLException;

   InputStream getAsciiStream(int var1) throws SQLException;

   InputStream getUnicodeStream(int var1) throws SQLException;

   InputStream getBinaryStream(int var1) throws SQLException;

   String getString(String var1) throws SQLException;

   boolean getBoolean(String var1) throws SQLException;

   byte getByte(String var1) throws SQLException;

   short getShort(String var1) throws SQLException;

   int getInt(String var1) throws SQLException;

   long getLong(String var1) throws SQLException;

   float getFloat(String var1) throws SQLException;

   double getDouble(String var1) throws SQLException;

   BigDecimal getBigDecimal(String var1, int var2) throws SQLException;

   byte[] getBytes(String var1) throws SQLException;

   Date getDate(String var1) throws SQLException;

   Time getTime(String var1) throws SQLException;

   Timestamp getTimestamp(String var1) throws SQLException;

   InputStream getAsciiStream(String var1) throws SQLException;

   InputStream getUnicodeStream(String var1) throws SQLException;

   InputStream getBinaryStream(String var1) throws SQLException;

   SQLWarning getWarnings() throws SQLException;

   void clearWarnings() throws SQLException;

   String getCursorName() throws SQLException;

   ResultSetMetaData getMetaData() throws SQLException;

   Object getObject(int var1) throws SQLException;

   Object getObject(String var1) throws SQLException;

   int findColumn(String var1) throws SQLException;
}
