package java.sql;

public class SQLException extends Exception {
   private String SQLState;
   private int vendorCode;
   private SQLException next;

   public SQLException(String var1, String var2, int var3) {
      super(var1);
      this.SQLState = var2;
      this.vendorCode = var3;
      if (!(this instanceof SQLWarning) && DriverManager.getLogStream() != null) {
         DriverManager.println("SQLException: SQLState(" + var2 + ") vendor code(" + var3 + ")");
         ((Throwable)this).printStackTrace(DriverManager.getLogStream());
      }

   }

   public SQLException(String var1, String var2) {
      super(var1);
      this.SQLState = var2;
      this.vendorCode = 0;
      if (!(this instanceof SQLWarning) && DriverManager.getLogStream() != null) {
         ((Throwable)this).printStackTrace(DriverManager.getLogStream());
         DriverManager.println("SQLException: SQLState(" + var2 + ")");
      }

   }

   public SQLException(String var1) {
      super(var1);
      this.SQLState = null;
      this.vendorCode = 0;
      if (!(this instanceof SQLWarning) && DriverManager.getLogStream() != null) {
         ((Throwable)this).printStackTrace(DriverManager.getLogStream());
      }

   }

   public SQLException() {
      this.SQLState = null;
      this.vendorCode = 0;
      if (!(this instanceof SQLWarning) && DriverManager.getLogStream() != null) {
         ((Throwable)this).printStackTrace(DriverManager.getLogStream());
      }

   }

   public String getSQLState() {
      return this.SQLState;
   }

   public int getErrorCode() {
      return this.vendorCode;
   }

   public SQLException getNextException() {
      return this.next;
   }

   public synchronized void setNextException(SQLException var1) {
      SQLException var2;
      for(var2 = this; var2.next != null; var2 = var2.next) {
      }

      var2.next = var1;
   }
}
